
!"Pocket Smalltalk fileout - Saturday, April 20, 2002-10:37:19 PM"!


!Object constantsFor: 'PasswordGeneratorWidgets'!

PGAbout 1501! 
PGExit 1599! 
PGMainForm 2000! 
PGMaxSize 2105! 
PGMinSize 2103! 
PGPhrase 2201! 
PGPhraseMenu 1503! 
PGSizeList 2104! 
PGwDigits 2102! 
PGwoDigits 2101! 
PGWords 2200! 
PGWordsMenu 1502! !

!Object constantsFor: 'Resource Databases'!

resourceDB1 '*.bin'! 
resourceDB2 '..\..\..\Program Files\Pocket Smalltalk 1.6 alpha 4\palmos\vm16amf.prc'! !

!Object constantsFor: 'System Properties'!

applicationTitle 'Passwords'! 
creatorID 'nvVW'! !

Application subclass: #PasswordGenerator
	instanceVariableNames: 'minSize maxSize woDigitsModel wDigitsModel sizeListModel phraseMaker wordBox'
	classVariableNames: ''!

Object subclass: #PhraseMaker
	instanceVariableNames: 'resultSize verbs articles adjectives nouns adverbs verbsUsed articlesUsed adjectivesUsed nounsUsed adverbsUsed wordList resultWord wordX'
	classVariableNames: ''!

Object subclass: #WordBox
	instanceVariableNames: 'database resultWord tableX table prefixSum length tt rr cc'
	classVariableNames: ''!

!PasswordGenerator comment!
This object, plus the objects titled "PhraseMaker" and "WordBox" as most other code, is based on the works of others.  See the comments with "WordBox" for the copyright information by Klaus Rindtorff.  "PhraseMaker" is based on ideas from poetry writing programs found in various parts of the web.  Sorry I can't give full credit to where the ideas came from.. but they are actually a comgolmeration from others.

Copyright (c) 2002 by Nicholas Vrtis.
Permission to us, copy, and distribute this software and its documentation for any purpose, without fee, and without a written agreement is hereby granted, provided that the above copyright notice and this paragraph and the following two paragraphs appear in all copies.
In no event shall the author be liable to any party for direct, indirect, special, incidental, or consequential damages, including lost profits, arising out of the use of this software and its documentation, even if the author has been advised of the possibility of such damage.
The author specifically disclaims any warranties, including, but not limited to, the implied warranties of merchantability and fitness for a particular purpose. The software provided hereunder is on an "as is" basis, and the author has no obligations to provide maintenance, support, updates, enhancements, or modifications.
! !


!PasswordGenerator methodsFor: 'initialization'!

initialize
	"This is where we set up some basic stuff"
	super initialize.
	minSize := 6.
	maxSize := 9.
	woDigitsModel := ListModel list: #(' ').
	wDigitsModel := ListModel list: #(' ').
	sizeListModel := ListModel list: #('5' '6' '7' '8' '9' '10' '11' '12').
	phraseMaker := PhraseMaker new.
	wordBox := WordBox new.
!

createComponents
	"Bind the screen widgets to our application"
	super createComponents.
	self add: Button id: ##PGWords name: nil aspect: #makeWords.
	self add: Button id: ##PGPhrase name: nil aspect: #makePhrase.
	self add: Listbox id:##PGwoDigits name: nil aspect: #woDigits.
	self add: Listbox id:##PGwDigits name: nil aspect: #wDigits.
	self add: Listbox id:##PGSizeList name: nil aspect: #sizeList.
	self add: PopupTrigger id: ##PGMinSize name: nil aspect: nil.
	self add: PopupTrigger id: ##PGMaxSize name: nil aspect: nil.
!

createMenus
	"Initialization of the menu entries"
	super createMenus.
	self addMenuAction: #aboutMenu forID: ##PGAbout.
	self addMenuAction: #makeWords forID: ##PGWordsMenu.
	self addMenuAction: #makePhrase forID: ##PGPhraseMenu.
	self addMenuAction: #exitMenu forID: ##PGExit.
! !


!PasswordGenerator methodsFor: 'actions'!

exitMenu
	"Stop and return to Palm Applications Panel"
	self class eventuallyExitSmalltalk.
!

aboutMenu
	"Tell everybody a little about ourselves"
	Form notify: 'PasswordGenerator V.1.0.  Copyright 2002, Nicholas J. Vrtis'.
!

makeWords
	|wod wd aWord thisSize|
	self setSizes.
	wod := List new: 10.	"Allocate the lists to collect the word into"
	wd := List new: 10.
	wDigitsModel list: wd.
	woDigitsModel list: wod.
	1 to: 10 do: [ :i |
		maxSize == minSize ifTrue: [
			thisSize := minSize.
		]
		ifFalse: [
			thisSize := (minSize + (PalmOS random \\ (maxSize - minSize))).
		].
		aWord := wordBox generate: thisSize.
		wDigitsModel at: i put: (self subDigits: aWord).
		woDigitsModel at: i put:  aWord.
		wDigitsModel list: wd.
		woDigitsModel list: wod.
	].
!

makePhrase
	|pwList z|
	self setSizes.
	z := maxSize - minSize.
	z == 0 ifTrue: [
		phraseMaker generate: minSize.
	]
	ifFalse: [
		phraseMaker generate: (minSize + (PalmOS random \\ z)).
	].
	woDigitsModel list: phraseMaker getList.
	pwList := List new: 2.
	pwList at: 1 put: phraseMaker getResultWord.
	pwList at: 2 put: (self subDigits: (pwList at: 1)).
	wDigitsModel list: pwList.! !


!PasswordGenerator methodsFor: 'event handling'!

handlePopSelectEvent
	"Only need to return 'false' so that title get's updated"
	super handlePopSelectEvent.
	^false.!

handleFormLoadEvent
	super handleFormLoadEvent.
	"Fill in the form with a password.  Use Phrase because it's faster"
	self makePhrase.
	^true.! !


!PasswordGenerator methodsFor: 'accessing'!

woDigits
	^woDigitsModel.!

wDigits
	^wDigitsModel.!

sizeList
	sizeListModel selection: nil.		"Clear any previous selections"
	^sizeListModel! !


!PasswordGenerator methodsFor: 'private'!

subDigits: aWord
	|fc td z dWord|
	dWord := String withAll: aWord.
	fc := 'EIOGSZP'.
	td := '3106829'.
	1 to: fc size do: [ :x |		"Don't substitute the 1st character with a digit"
		[(z := dWord indexOf: (fc at: x)) > 1] whileTrue: [dWord at: z put: (td at: x)].
	].
	^dWord.!

setSizes
	|widget temp|
	widget := self widgetWithID: ##PGMinSize.
	minSize := widget label.
	minSize := Integer fromString: minSize.
	widget := self widgetWithID: ##PGMaxSize.
	maxSize := widget label.
	maxSize := Integer fromString: maxSize.
	maxSize < minSize ifTrue: [	"Make sure max > min"
		temp := maxSize.	"If not, swap the two"
		maxSize := minSize.
		minSize := temp.
	].
	maxSize := maxSize + 1.
! !


!PasswordGenerator class methodsFor: 'accessing'!

formID
	^##PGMainForm! !


!PhraseMaker methodsFor: 'initialization'!

initialize
	verbs := Array withAll: PhraseMaker verbs.
	articles := Array withAll: PhraseMaker articles.
	adjectives := Array withAll: PhraseMaker adjectives.
	nouns := Array withAll: PhraseMaker nouns.
	adverbs := Array withAll: PhraseMaker adverbs.
	^self.! !


!PhraseMaker methodsFor: 'accessing'!

getList
	"Returns the list of the words that were generated"
	^wordList.!

getResultWord
	"Returns the result word that consists of the 1st letters of each word in the phrase"
	^resultWord.!

generate: size
	resultSize := size.			"Save the resulting size wanted"
	wordX := 1.				"Start at the beginning of the list"
	wordList := List new: resultSize.		"Start the phrase list"
	wordList atAllPut: ' '.
	resultWord := String new: resultSize.	"Create the resulting 'word' sting"
	resultWord atAllPut: Character space.
	(PalmOS random \\ 2) ==0 ifTrue: [
		^self format1Word.
	]
	ifFalse: [
		^self format2Word.
	].! !


!PhraseMaker methodsFor: 'private'!

resetFrom: s to: t
	"Reset the allowed words from 's' array to 't' array"
	1 to: s size do: [ :i |
		t at: i put: (s at: i).
	].!

pickAWordFrom: theList reset: masterList
	|x w|
	w := x := (PalmOS random \\ (theList size)) + 1.	"Save the starting point to detect wrapping"
	[(theList at: x) isNil] whileTrue: [		"Find the first unused word"
		x := x + 1.			"Advance to next slot"
		(x > (theList size)) ifTrue: [x := 1].
		x == w ifTrue: [self resetFrom: masterList to: theList].	"Reset  and reuse if it wraps"
	].
	w := theList at: x.			"Save the word so I can return it"
	theList at: x put: nil.			"This word is used"
	^w.				"Returns the word found"!

addAWord: word
	|w|
	resultWord at: wordX put: (word at: 1) asUppercase.	"1st char is for the password"
	w := word copy.			"Make a copy so I can capitalize if necessary"
	wordX == 1 ifTrue: [			"Capitalize 1st word of sentence"
		w at: 1 put: (word at: 1) asUppercase.
	].
	wordList at: wordX put: w.
	wordX := wordX + 1.
	^w.!

trimOpts: opts fromSize: fs
	|len x y|
	len := fs.
	[len>resultSize] whileTrue: [
		x := (PalmOS random \\ (opts size)) + 1.
		"Form notify: 'RS=', resultSize displayString, ' L=',len displayString."
		y := opts at: x.
		y > 0 ifTrue: [
			opts at: x put: (y - 1).
			len := len - 1].
	].
!

format1Word
	|opts aWord artX x plural|
	"Format 1 is 'Art' 'Adj (0-3) 'Noun' 'Adv(0-1) 'Verb' 'Art' 'Adj(0-3)' 'Noun' '.'"
	opts := List withAll: #(3 1 3).		"Posn 1=adj1, 2=adv, 3=adj2"
	self trimOpts: opts fromSize: 12.
	artX := 1.				"May need to fix up the article (A, An, etc.)"
	aWord := self pickAWordFrom: articles reset: self class articles.
	self addAWord: aWord.
	plural := self isPlural: aWord.
	x := opts at: 1.				"Maybe some adjectives"
	[x > 0] whileTrue: [
		self addAWord: (self pickAWordFrom: adjectives reset: self class adjectives).
		x := x - 1.
	].
	aWord := self pickAWordFrom: nouns reset: self class nouns.
	plural ifTrue: [aWord := aWord, 's'].
	self addAWord: aWord.
	"Now I have at least two words... so can check for 'a' vs 'an'"
	'A' = (wordList at: 1) ifTrue: [
		('aeiou' includes: ((wordList at: 2) at: 1)) ifTrue: [
			wordList at: 1 put: 'An'.
		].
	].
	x := opts at: 2.				"Maybe some adverbs"
	[x > 0] whileTrue: [
		self addAWord: (self pickAWordFrom: adverbs reset: self class adverbs).
		x := x - 1.
	].
	aWord := self pickAWordFrom: verbs reset: self class verbs.
	plural ifFalse: [aWord := aWord, 's'].	"Add the 's' if it is a singular adjectives"
	self addAWord: aWord.
	artX := wordX.				"Save where the adjective is"
	aWord := self pickAWordFrom: articles reset: self class articles.
	plural := self isPlural: aWord.
	self addAWord: aWord.
	x := opts at: 3.				"Maybe some more adjectives"
	[x > 0] whileTrue: [
		self addAWord: (self pickAWordFrom: adjectives reset: self class adjectives).
		x := x - 1.
	].
	aWord := self pickAWordFrom: nouns reset: self class nouns.
	plural ifTrue: [aWord := aWord, 's'].
	aWord := aWord, '.'.			"End of sentence"
	self addAWord: aWord.
	'a' = (wordList at: artX) ifTrue: [
		('aeiou' includes: ((wordList at: (artX + 1)) at: 1)) ifTrue: [
			wordList at: artX put: 'an'.
		].
	].
	^resultWord.!

format2Word
	|opts aWord x plural|
	resultSize > 7 ifTrue: [^self format1Word].	"Can only handle up to 7 characters with format2"
	"Format 2 is 'Art' 'Adj (0-3) 'Noun' 'Adv(0-1) 'Verb'  '!!'"
	opts := List withAll: #(3 1).		"Posn 1=adj1, 2=adv"
	self trimOpts: opts fromSize: 7.
	aWord := self pickAWordFrom: articles reset: self class articles.
	self addAWord: aWord.
	plural := self isPlural: aWord.
	x := opts at: 1.				"Maybe some adjectives"
	[x > 0] whileTrue: [
		self addAWord: (self pickAWordFrom: adjectives reset: self class adjectives).
		x := x - 1.
	].
	aWord := self pickAWordFrom: nouns reset: self class nouns.
	plural ifTrue: [aWord := aWord, 's'].
	self addAWord: aWord.
	"Now I have at least two words... so can check for 'a' vs 'an'"
	'A' = (wordList at: 1) ifTrue: [
		('aeiou' includes: ((wordList at: 2) at: 1)) ifTrue: [
			wordList at: 1 put: 'An'.
		].
	].
	x := opts at: 2.				"Maybe some adverbs"
	[x > 0] whileTrue: [
		self addAWord: (self pickAWordFrom: adverbs reset: self class adverbs).
		x := x - 1.
	].
	aWord := self pickAWordFrom: verbs reset: self class verbs.
	plural ifFalse: [aWord := aWord, 's'].	"Add the 's' if it is a singular adjectives"
	aWord := aWord, '!!'.
	self addAWord: aWord.
	^resultWord.!

isPlural: word
	^#('all' 'both' 'four' 'their' 'many' 'some') includes: word.! !


!PhraseMaker class methodsFor: 'instance creation'!

new
	^super new initialize.
! !


!PhraseMaker class methodsFor: 'access'!

adjectives
^#('ancient' 'angry' 'blue' 'bland' 'clean' 'cold' 'cool' 'dirty' 'dark' 'effective' 'evil' 'filthy' 'flat' 'folded' 'green' 'greasy' 'hot' 'icy' 'juicy' 'kind' 'likable' 'lovely' 'moldy' 'necessary' 'nice' 'old' 'odd' 'plastic' 'pretty' 'quiet' 'quick' 'red' 'round' 'slippery' 'smelly' 'tame' 'timid' 'uniform' 'upright' 'vibrant' 'wild' 'white' 'yellow').!

adverbs
^#('abruptly' 'always' 'basically' 'brightly' 'cheerfully' 'deliverately' 'eagerly' 'finally' 'grimly' 'happily' 'hysterically' 'immediately' 'immensely' 'justly' 'kindly' 'lightly' 'loudly' 'moodily' 'never' 'painfully' 'quietly' 'quickly' 'rapidly' 'rarely' 'remorselessly' 'sadly' 'slowly' 'suddenly' 'timidly' 'uncomfortably' 'undesirably' 'wetly' 'wildly').!

nouns
"These need to be such that adding an 's' to the end makes them plural."
^#('arm' 'apple' 'bear' 'boat' 'book' 'bottle' 'car' 'cat' 'chicken' 'clock' 'computer' 'cow' 'dog' 'door' 'eagle' 'elbow' 'finger' 'file' 'ghost' 'hose' 'hotel' 'image' 'jack' 'jar' 'key' 'kite' 'lamp' 'map' 'mixer' 'mother' 'name' 'napkin' 'nose' 'oar' 'opener' 'pear' 'printer' 'quill' 'rat' 'rainbow' 'shoe' 'snake' 'soap' 'train' 'truck' 'thumb' 'umbrella' 'uncle' 'vessel' 'video' 'vowel' 'wrench' 'window' 'xray' 'zebra').!

verbs
"These need to be such that 'singular' just adds and 's' at the end."
^#('argue' 'bite' 'buy' 'crash' 'cut' 'drink' 'drive' 'drop' 'eat' 'enter' 'exhale' 'fall' 'find' 'follow' 'get' 'give' 'grasp' 'hit' 'hurt' 'ignore' 'imagine' 'jump' 'jab' 'kick' 'kneel' 'lick' 'lift' 'look' 'melt' 'mold' 'nag' 'order' 'open' 'overflow' 'place' 'plead' 'quiz' 'read' 'run' 'sing' 'sip' 'slam' 'smell' 'take' 'touch' 'understand' 'usurp' 'vex' 'wave' 'whisper').!

articles
^#('a' 'all' 'both' 'each' 'four' 'her' 'his' 'many' 'my' 'no' 'none' 'one' 'some' 'that' 'the' 'their' 'this' 'your').! !


!WordBox comment!
Based on the Waba/Java program called WordBox.

Copyright 1999 by Klaus Rindtorff.
Permission to us, copy, and distribute this software and its documentation for any purpose, without fee, and without a written agreement is hereby granted, provided that the above copyright notice and this paragraph and the following two paragraphs appear in all copies.
In no event shall the author be liable to any party for direct, indirect, special, incidental, or consequential damages, including lost profits, arising out of the use of this software and its documentation, even if the author has been advised of the possibility of such damage.
The author specifically disclaims any warranties, including, but not limited to, the implied warranties of merchantability and fitness for a particular purpose. The software provided hereunder is on an "as is" basis, and the author has no obligations to provide maintenance, support, updates, enhancements, or modifications.
! !


!WordBox methodsFor: 'initialization'!

initialize
	database := Database open: 'WordBox English' mode: ##dmModeReadOnly.
	self setPrefixSum.
	^self
! !


!WordBox methodsFor: 'accessing'!

getResultWord
	^resultWord.!

generate: resultLength
	resultWord := String new: resultLength.
	length := 0.
	[length < resultWord size] whileTrue: [
		"select_prefix"
		self selectPrefix.
		"select_next"
		self selectNext.
	].
	^resultWord.! !


!WordBox methodsFor: 'private'!

getProbabilitytable: t row: r character: c
	|temp|
	t == tableX ifFalse: [		"See if already got the table record"
		table := database recordAsBytes: t.
		tableX := t.
	].
	temp := table at: (r * 28 + c + 1).
	temp < 0 ifTrue: [Form notify: 'Got a negative', t displayString, r displayString, c displayString, temp displayString.].
	^temp.
	!

setPrefixSum
	prefixSum := 0.
	0 to: 25 do: [ :i |
		0 to: 25 do: [ :j |
			prefixSum := prefixSum + (self getProbabilitytable: i row: j character: 26).
		].
	].
	^prefixSum.!

infixSumtable: t row: r
	|sum|
	sum := 0.
	0 to: 25 do: [ :c |
		sum := sum + (self getProbabilitytable: t row: r character: c).
	].
	^sum.!

suffixSumtable: t row: r
	|sum|
	sum := 0.
	0 to: 25 do: [ :c |
		(self getProbabilitytable: t row: r character: c) > 0 ifTrue: [
			sum := sum + (self getProbabilitytable: t row: r character: 27).
		].
	].
	^sum.!

selectNext
	|sigma sum|
	[length < resultWord size] whileTrue: [
		(length == (resultWord size - 1) and: [length > 1]) ifTrue: [
			sigma := self suffixSumtable: tt row: rr.
			sigma > 0 ifTrue: [
				sigma := PalmOS random \\ sigma.
				sum := 0.
				cc := 0.
				[cc < 26] whileTrue: [
					"See if it makes an existing trigram"
					(self getProbabilitytable: tt row: rr character: cc) == 0 ifFalse: [
						sum := sum + (self getProbabilitytable: tt row: rr character: 27).
						sum > sigma ifTrue: [
							length := length + 1.
							resultWord at: length put: (Character value: ($A asInteger + cc)).
							^length.
						].
					].
					cc := cc + 1.
				].
			].
		].
		sigma := self infixSumtable: tt row: rr.
		sigma == 0 ifTrue: [
			^length.
		].
		self selectTrigram.
	].
!

selectPrefix
	|sigma sum a|
	a := $A asInteger.
	[true] whileTrue: [		"Selected a prefix (2 characters"
		sigma := PalmOS random \\ prefixSum.
		sum := 0.
		tt := 0.
		[tt < 26] whileTrue: [
			rr := 0.
			[rr < 26] whileTrue: [
				sum := sum + (self getProbabilitytable: tt row: rr character: 26).
				sum > sigma ifTrue: [
					length < resultWord size ifTrue: [
						length := length + 1.
						resultWord at: length put: (Character value: (a + tt)).
					].
					length < resultWord size ifTrue: [
						length := length + 1.
						resultWord at: length put: (Character value: (a + rr)).
					].
					^length.
				].
				rr := rr + 1.
			].
			tt := tt + 1.
		].
	].
	^length.		"Should never exit this way"!

selectTrigram
	|sigma sum|
	sigma := PalmOS random \\ (self infixSumtable: tt row: rr).
	sum := 0.
	cc := 0.
	[cc < 26] whileTrue: [
		sum := sum + (self getProbabilitytable: tt row: rr character: cc).
		sum > sigma ifTrue: [
			length := length + 1.
			resultWord at: length put: (Character value: ($A asInteger + cc)).
			tt := rr.
			rr := cc.
			^length.
		].
		cc := cc + 1.
	].
	^length.			"Should never exit this way"
	! !


!WordBox class methodsFor: 'instance creation'!

new
	^super new initialize.! !


!Smalltalk class methodsFor: 'startup'!

start
	"Put your startup code here!!!!"
	PasswordGenerator show.
! !


!Listbox methodsFor: 'updating'!

updateModelFromSelection
	"NJV - Bug fix... needs to return 1..n/0=not selected"
	| index |
	model ifNotNil: [
		index := SYSTRAP LstGetSelection: self getPointer.
		model selectionIndex: (index >= 65535
			ifTrue: [0]
			ifFalse: [index +1])].! !


